package com.example.demo;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import java.util.logging.Level;
import java.util.logging.Logger;

import java.io.File;
import java.io.IOException;
import java.time.LocalDateTime;

@RestController
@RequestMapping("/demo")
public class MyController {
    private static final Logger logger = Logger.getLogger(DemoApplication.class.getName());

    @Autowired
    private FileInfoRepository fileInfoRepository;

    final String PATH = "data";
    @GetMapping("/hello")
    public String hello() {
        return "hello";
    }

    @PostMapping("/upload")
    public String uploadFile(@RequestParam("file") MultipartFile file) {
        if (file.isEmpty()) {
            return "No file selected to upload.";
        }

        try {
            // Create the directory if it doesn't exist
            File directory = new File(PATH);
            if (!directory.exists()) {
                directory.mkdirs();
            }

            // Save the file
            String filePath = PATH + File.separator + file.getOriginalFilename();
            String mypath = new File("." + PATH).getAbsolutePath();
            String finalPath = mypath.split("\\.")[0];
            file.transferTo(new File(finalPath + filePath));
            saveFileToDB(file.getOriginalFilename());
            return "File uploaded successfully: ";
        } catch (IOException e) {
            e.printStackTrace();
            logger.log(Level.SEVERE, "error log");
            return "Failed to upload file.";
        }
    }

    void saveFileToDB(String fileName) {
        FileInfo fileInfo = new FileInfo();
        fileInfo.setFileName(fileName);
        fileInfo.setSaveAt(LocalDateTime.now());
        fileInfoRepository.save(fileInfo);
        logger.log(Level.INFO, "fileName saved to db");
    }
}
